Index: logic/trunk/devicetree.xml
===================================================================
--- logic/trunk/devicetree.xml	(revision 0)
+++ logic/trunk/devicetree.xml	(revision 38)
@@ -0,0 +1,33 @@
+<?xml version="1.0"?>
+<devicetree>
+    <device id="thermometer_01">
+        <name nam="Thermometer"></name>
+        <read_interval rditv="10"/>
+        <action act="testAction_1"></action>
+        <param par="testParam_1"></param>
+    </device>
+    <device id="barometer_01">
+        <name nam="Barometer"></name>
+        <read_interval rditv="20"/>
+        <action act="testAction_2"></action>
+        <param par="testParam_2"></param>
+    </device>
+    <device id="hygrometer_01">
+        <name nam="Hygrometer"></name>
+        <read_interval rditv="30"/>
+        <action act="testAction_3"></action>
+        <param par="testParam_3"></param>
+    </device>
+    <device id="light_sensor_01">
+        <name nam="Light sensor"></name>
+        <read_interval rditv="1"/>
+        <action act="testAction_4"></action>
+        <param par="testParam_4"></param>
+    </device>
+    <device id="smart_meter_01">
+        <name nam="Smart meter"></name>
+        <read_interval rditv="3"/>
+        <action act="testAction_5"></action>
+        <param par="testParam_5"></param>
+    </device>
+</devicetree>
Index: logic/trunk/eneraptor.cbp
===================================================================
--- logic/trunk/eneraptor.cbp	(revision 37)
+++ logic/trunk/eneraptor.cbp	(revision 38)
@@ -52,6 +52,15 @@
 		</Unit>
 		<Unit filename="src/init/devicelist.h" />
 		<Unit filename="src/init/initialisation.h" />
+		<Unit filename="src/init/scenariolist.c">
+			<Option compilerVar="CC" />
+		</Unit>
+		<Unit filename="src/init/scenariolist.h" />
+		<Unit filename="src/logics/conditions.h" />
+		<Unit filename="src/logics/operators.c">
+			<Option compilerVar="CC" />
+		</Unit>
+		<Unit filename="src/logics/operators.h" />
 		<Unit filename="src/startup/main.c">
 			<Option compilerVar="CC" />
 			<Option weight="0" />
Index: logic/trunk/scenariotree.xml
===================================================================
--- logic/trunk/scenariotree.xml	(revision 0)
+++ logic/trunk/scenariotree.xml	(revision 38)
@@ -0,0 +1,45 @@
+<?xml version="1.0"?>
+<scenariotree>
+  <scenario id="scenario_01" name="Klima na stropu, w/e">
+    <inDevice id="thermometer_01" />
+    <outDevice id="air_cond_01" />
+    <reaction func="linear" />
+    <check_idle val="600" />
+    <check_active val="60" />
+    <params val="--lazy=true" />
+    <inDevAalues minval="20" maxval="28" optval="24" tolerance="0.5"/>
+    <action act="testAction_1"/>
+    <param par="testParam_1"/>
+    <conditions>
+      <and>
+        <greater inDeviceId="barometer_01" val="80" />
+        <less_or_equal inDeviceId="lightSensor" val="50" />
+        <or>
+          <greater inDeviceId="time" val="1500" />
+          <less inDeviceId="time" val="1000" />
+        </or>
+      </and>
+    </conditions>
+  </scenario>
+    <scenario id="scenario_02" name="Klima v kleti, w/e">
+    <inDevice id="thermometer_01" />
+    <outDevice id="air_cond_01" />
+    <reaction func="linear" />
+    <check_idle val="600" />
+    <check_active val="60" />
+    <params val="--lazy=true" />
+    <inDevAalues minval="20" maxval="28" optval="24" tolerance="0.5"/>
+    <action act="testAction_1"/>
+    <param par="testParam_1"/>
+    <conditions>
+      <and>
+        <greater inDeviceId="barometer_01" val="80" />
+        <less_or_equal inDeviceId="lightSensor" val="50" />
+        <or>
+          <greater inDeviceId="time" val="1500" />
+          <less inDeviceId="time" val="1000" />
+        </or>
+      </and>
+    </conditions>
+  </scenario>
+</scenariotree>
Index: logic/trunk/config.xml
===================================================================
--- logic/trunk/config.xml	(revision 0)
+++ logic/trunk/config.xml	(revision 38)
@@ -0,0 +1,8 @@
+<init_config>
+    <!--device containers-->
+    <devices>
+        <device id="Thermometer_01">
+            <value>24</value>
+        </device>
+    </devices>
+</init_config>