Index: hci/trunk/eneraptor-web-app/web-app/css/style.css
===================================================================
--- hci/trunk/eneraptor-web-app/web-app/css/style.css	(revision 66)
+++ hci/trunk/eneraptor-web-app/web-app/css/style.css	(revision 67)
@@ -360,6 +360,15 @@
 	margin:5px;
 	font-family:monospace;	
 }
+
+#legendHolder .legendColorBox {
+	width: 18px;
+}
+
+#legendHolder .legendLabel {
+	font-size:12px !important;
+}
+
 /*********************
 	Icons
 *********************/
@@ -367,7 +376,7 @@
 	padding-left:19px;
 	text-decoration:none;
 	height:20px;
-	font-size:12x;
+	font-size:12px;
 	margin:0 3px;
 	display:inline-block;
 	line-height:20px;
Index: hci/trunk/eneraptor-web-app/grails-app/controllers/com/eneraptor/hci/StatisticsController.groovy
===================================================================
--- hci/trunk/eneraptor-web-app/grails-app/controllers/com/eneraptor/hci/StatisticsController.groovy	(revision 66)
+++ hci/trunk/eneraptor-web-app/grails-app/controllers/com/eneraptor/hci/StatisticsController.groovy	(revision 67)
@@ -107,7 +107,7 @@
 		List data = new ArrayList()
 		data = graphDataService.getGraphData(graphToShow)
 		
-		[data:data]
+		[data: "{label: '" + graphToShow.name + "', data: " + data.toString() + " }"]
 		
 	}
 	
@@ -593,7 +593,7 @@
 				List datas = new ArrayList()
 				
 				chGrph.graphs.each {
-					datas << graphDataService.getGraphData(it)
+					datas << "{label: '" + it.name + "', data: " + graphDataService.getGraphData(it).toString() + "}"
 				}
 				
 				return [data: datas]
Index: hci/trunk/eneraptor-web-app/grails-app/controllers/com/eneraptor/hci/ConfigController.groovy
===================================================================
--- hci/trunk/eneraptor-web-app/grails-app/controllers/com/eneraptor/hci/ConfigController.groovy	(revision 66)
+++ hci/trunk/eneraptor-web-app/grails-app/controllers/com/eneraptor/hci/ConfigController.groovy	(revision 67)
@@ -11,31 +11,9 @@
 	
 	def hci = {
 		
-		/*
-		 * DISK USAGE - ONLY IF ENERAPTOR HCI IS SUPERUSER
-		 */ 
-		def totalSpace = 0
-		def freeSpace = 0
-		def percent = 0
-		/*
-		def db_sql = new Sql(dataSource)
-		
-		def single = db_sql.firstRow("show data_directory")
-		def loca = single.data_directory
-		def partition = new File(loca)
-		totalSpace = partition.getTotalSpace()
-		freeSpace  = partition.getFreeSpace()
-		
-		totalSpace = (int)((totalSpace/1024)/1024)
-		freeSpace = (int)((freeSpace/1024)/1024)
-		
-		percent = 100 - ((int) ((freeSpace/totalSpace)*100))
-		
-		*/
-		
 		def allDevices = HardwareSet.get(session.hwSet.id).devices
 		
-		[conf: InternalConfig, devices: allDevices, totalSpace: totalSpace, freeSpace: freeSpace, percent: percent]		
+		[conf: InternalConfig, devices: allDevices]		
 	}
 	
 	def addDevice = {
Index: hci/trunk/eneraptor-web-app/grails-app/views/statistics/showGraph.gsp
===================================================================
--- hci/trunk/eneraptor-web-app/grails-app/views/statistics/showGraph.gsp	(revision 66)
+++ hci/trunk/eneraptor-web-app/grails-app/views/statistics/showGraph.gsp	(revision 67)
@@ -14,12 +14,17 @@
 			var options = {
 				lines: { show: true },
 				points: { show: true },
-				xaxis: { mode: "time", timeformat: "%y/%m/%d %H:%M" }
+				xaxis: { mode: "time", timeformat: "%y/%m/%d %H:%M" },
+				legend: { container: '#legendHolder' }
 			};
 		</g:javascript>
 		<div class="chart">
 			<flot:plot id="placeholder" style="width: 900px; height: 300px; padding:5px;" data="data" options="options" />
 		</div>
+		<br />
+		<p>Legend:</p>
+		<div id="legendHolder" name="legendHolder"></div>
+		
 	</erptr:box>
 
 </body>
Index: hci/trunk/eneraptor-web-app/grails-app/views/statistics/showCombGraph.gsp
===================================================================
--- hci/trunk/eneraptor-web-app/grails-app/views/statistics/showCombGraph.gsp	(revision 66)
+++ hci/trunk/eneraptor-web-app/grails-app/views/statistics/showCombGraph.gsp	(revision 67)
@@ -15,9 +15,7 @@
 				lines: { show: true },
 				points: { show: true },
 				xaxis: { mode: "time", timeformat: "%y/%m/%d %H:%M" },
-				legend: {
-				    container: $('legendContainer')
-				}
+				legend: { container: '#legendHolder' }
 			};
 		</g:javascript>
 		<div class="chart">
@@ -25,7 +23,8 @@
 		</div>
 		<br />
 		<p>Legend:</p>
-		<div id="legendContainer" name="legendContainer"></div>
+		<div id="legendHolder" name="legendHolder"></div>
+		
 	</erptr:box>
 
 </body>
Index: hci/trunk/eneraptor-web-app/grails-app/views/config/database.gsp
===================================================================
--- hci/trunk/eneraptor-web-app/grails-app/views/config/database.gsp	(revision 66)
+++ hci/trunk/eneraptor-web-app/grails-app/views/config/database.gsp	(revision 67)
@@ -6,21 +6,6 @@
 </head>
 
 <body>
-
-		<!-- DISK USAGE - ONLY IF ENERAPTOR HCI IS SUPERUSER	
-			<p style="float: left;">Disk usage: &nbsp;&nbsp;&nbsp;</p>
-			<div style="float:left;">
-				<div style="width: 100px;border:1px solid grey;">
-					<div style="width:${percent}px;background:grey;">
-						&nbsp;
-					</div>
-				</div>
-			</div>
-			<span> &nbsp;&nbsp;&nbsp; ${percent}% (free space ${(int)freeSpace} MB) </span>
-			<g:if test="${percent >= 95}">
-					<i style="color:red;">&nbsp;&nbsp;&nbsp;Warning: disk is almost full. You should erase some old log entries.</i>
-			</g:if>
-		-->
 	
 	<erptr:box title="Database information">
 	